# frozen_string_literal: true

# APK_TOOLS_TEST_CASES imported from https://github.com/alpinelinux/apk-tools/blob/6052bfef57a81d82451b4cad86f78a2d01959767/tests/version.data
APK_TOOLS_TEST_CASES = [
  ['2.34', 1, '0.1.0_alpha'],
  # ['23_foo', 1, '4_beta'], # Excluding as 23_foo is an invalid version
  ['1.0', -1, '1.0bc'], # invalid. do string sort
  ['0.1.0_alpha', 0, '0.1.0_alpha'],
  ['0.1.0_alpha', -1, '0.1.3_alpha'],
  ['0.1.3_alpha', 1, '0.1.0_alpha'],
  ['0.1.0_alpha2', 1, '0.1.0_alpha'],
  ['0.1.0_alpha', -1, '2.2.39-r1'],
  ['2.2.39-r1', 1, '1.0.4-r3'],
  ['1.0.4-r3', -1, '1.0.4-r4'],
  ['1.0.4-r4', -1, '1.6'],
  ['1.6', 1, '1.0.2'],
  ['1.0.2', 1, '0.7-r1'],
  ['0.7-r1', -1, '1.0.0'],
  ['1.0.0', -1, '1.0.1'],
  ['1.0.1', -1, '1.1'],
  ['1.1', 1, '1.1_alpha1'],
  ['1.1_alpha1', -1, '1.2.1'],
  ['1.2.1', 1, '1.2'],
  ['1.2', -1, '1.3_alpha'],
  ['1.3_alpha', -1, '1.3_alpha2'],
  ['1.3_alpha2', -1, '1.3_alpha3'],
  ['1.3_alpha8', 1, '0.6.0'],
  ['0.6.0', -1, '0.6.1'],
  ['0.6.1', -1, '0.7.0'],
  ['0.7.0', -1, '0.8_beta1'],
  ['0.8_beta1', -1, '0.8_beta2'],
  ['0.8_beta4', -1, '4.8-r1'],
  ['4.8-r1', 1, '3.10.18-r1'],
  ['3.10.18-r1', 1, '2.3.0b-r1'],
  ['2.3.0b-r1', -1, '2.3.0b-r2'],
  ['2.3.0b-r2', -1, '2.3.0b-r3'],
  ['2.3.0b-r3', -1, '2.3.0b-r4'],
  ['2.3.0b-r4', 1, '0.12.1'],
  ['0.12.1', -1, '0.12.2'],
  ['0.12.2', -1, '0.12.3'],
  ['0.12.3', 1, '0.12'],
  ['0.12', -1, '0.13_beta1'],
  ['0.13_beta1', -1, '0.13_beta2'],
  ['0.13_beta2', -1, '0.13_beta3'],
  ['0.13_beta3', -1, '0.13_beta4'],
  ['0.13_beta4', -1, '0.13_beta5'],
  ['0.13_beta5', 1, '0.9.12'],
  ['0.9.12', -1, '0.9.13'],
  ['0.9.13', 1, '0.9.12'],
  ['0.9.12', -1, '0.9.13'],
  ['0.9.13', 1, '0.0.16'],
  ['0.0.16', -1, '0.6'],
  ['0.6', -1, '2.1.13-r3'],
  ['2.1.13-r3', -1, '2.1.15-r2'],
  ['2.1.15-r2', -1, '2.1.15-r3'],
  ['2.1.15-r3', 1, '1.2.11'],
  ['1.2.11', -1, '1.2.12.1'],
  ['1.2.12.1', -1, '1.2.13'],
  ['1.2.13', -1, '1.2.14-r1'],
  ['1.2.14-r1', 1, '0.7.1'],
  ['0.7.1', 1, '0.5.4'],
  ['0.5.4', -1, '0.7.0'],
  ['0.7.0', -1, '1.2.13'],
  ['1.2.13', 1, '1.0.8'],
  ['1.0.8', -1, '1.2.1'],
  ['1.2.1', 1, '0.7-r1'],
  ['0.7-r1', -1, '2.4.32'],
  ['2.4.32', -1, '2.8-r4'],
  ['2.8-r4', 1, '0.9.6'],
  ['0.9.6', 1, '0.2.0-r1'],
  ['0.2.0-r1', 0, '0.2.0-r1'],
  ['0.2.0-r1', -1, '3.1_p16'],
  ['3.1_p16', -1, '3.1_p17'],
  # ['3.1_p17', 1, '1.06-r6'], # Numbers with leading zero not supported yet
  # ['1.06-r6', -1, '006'], # Numbers with leading zero not supported yet
  # ['006', 1, '1.0.0'], # Numbers with leading zero not supported yet
  ['1.0.0', -1, '1.2.2-r1'],
  ['1.2.2-r1', 1, '1.2.2'],
  ['1.2.2', 1, '0.3-r1'],
  ['0.3-r1', -1, '9.3.2-r4'],
  ['9.3.2-r4', -1, '9.3.4-r2'],
  ['9.3.4-r2', 1, '9.3.4'],
  ['9.3.4', 1, '9.3.2'],
  ['9.3.2', -1, '9.3.4'],
  ['9.3.4', 1, '1.1.3'],
  ['1.1.3', -1, '2.16.1-r3'],
  ['2.16.1-r3', 0, '2.16.1-r3'],
  ['2.16.1-r3', 1, '2.1.0-r2'],
  ['2.1.0-r2', -1, '2.9.3-r1'],
  ['2.9.3-r1', 1, '0.9-r1'],
  ['0.9-r1', 1, '0.8-r1'],
  ['0.8-r1', -1, '1.0.6-r3'],
  ['1.0.6-r3', 1, '0.11'],
  ['0.11', -1, '0.12'],
  ['0.12', -1, '1.2.1-r1'],
  ['1.2.1-r1', -1, '1.2.2.1'],
  ['1.2.2.1', -1, '1.4.1-r1'],
  ['1.4.1-r1', -1, '1.4.1-r2'],
  ['1.4.1-r2', 1, '1.2.2'],
  ['1.2.2', -1, '1.3'],
  ['1.3', 1, '1.0.3-r6'],
  ['1.0.3-r6', -1, '1.0.4'],
  ['1.0.4', -1, '2.59'],
  ['2.59', -1, '20050718-r1'],
  ['20050718-r1', -1, '20050718-r2'],
  ['20050718-r2', 1, '3.9.8-r5'],
  # ['3.9.8-r5', 1, '2.01.01_alpha10'], # Numbers with leading zero not supported yet
  # ['2.01.01_alpha10', 1, '0.94'], # Numbers with leading zero not supported yet
  ['0.94', -1, '1.0'],
  ['1.0', 1, '0.99.3.20040818'],
  ['0.99.3.20040818', 1, '0.7'],
  ['0.7', -1, '1.21-r1'],
  ['1.21-r1', 1, '0.13'],
  ['0.13', -1, '0.90.1-r1'],
  ['0.90.1-r1', 1, '0.10.2'],
  ['0.10.2', -1, '0.10.3'],
  ['0.10.3', -1, '1.6'],
  ['1.6', -1, '1.39'],
  # ['1.39', 1, '1.00_beta2'], # Numbers with leading zero not supported yet
  # ['1.00_beta2', 1, '0.9.2'], # Numbers with leading zero not supported yet
  ['0.9.2', -1, '5.94-r1'],
  ['5.94-r1', -1, '6.4'],
  ['6.4', 1, '2.6-r5'],
  ['2.6-r5', 1, '1.4'],
  ['1.4', -1, '2.8.9-r1'],
  ['2.8.9-r1', 1, '2.8.9'],
  ['2.8.9', 1, '1.1'],
  ['1.1', 1, '1.0.3-r2'],
  ['1.0.3-r2', -1, '1.3.4-r3'],
  ['1.3.4-r3', -1, '2.2'],
  ['2.2', 1, '1.2.6'],
  ['1.2.6', -1, '7.15.1-r1'],
  # ['7.15.1-r1', 1, '1.02'], # Numbers with leading zero not supported yet
  # ['1.02', -1, '1.03-r1'], # Numbers with leading zero not supported yet
  # ['1.03-r1', -1, '1.12.12-r2'], # Numbers with leading zero not supported yet
  ['1.12.12-r2', -1, '2.8.0.6-r1'],
  ['2.8.0.6-r1', 1, '0.5.2.7'],
  ['0.5.2.7', -1, '4.2.52_p2-r1'],
  ['4.2.52_p2-r1', -1, '4.2.52_p4-r2'],
  # ['4.2.52_p4-r2', 1, '1.02.07'], # Numbers with leading zero not supported yet
  # ['1.02.07', -1, '1.02.10-r1'], # Numbers with leading zero not supported yet
  # ['1.02.10-r1', -1, '3.0.3-r9'], # Numbers with leading zero not supported yet
  ['3.0.3-r9', 1, '2.0.5-r1'],
  ['2.0.5-r1', -1, '4.5'],
  ['4.5', 1, '2.8.7-r1'],
  ['2.8.7-r1', 1, '1.0.5'],
  ['1.0.5', -1, '8'],
  ['8', -1, '9'],
  ['9', 1, '2.18.3-r10'],
  # ['2.18.3-r10', 1, '1.05-r18'], # Numbers with leading zero not supported yet
  # ['1.05-r18', -1, '1.05-r19'], # Numbers with leading zero not supported yet
  # ['1.05-r19', -1, '2.2.5'], # Numbers with leading zero not supported yet
  ['2.2.5', -1, '2.8'],
  ['2.8', -1, '2.20.1'],
  ['2.20.1', -1, '2.20.3'],
  ['2.20.3', -1, '2.31'],
  ['2.31', -1, '2.34'],
  ['2.34', -1, '2.38'],
  ['2.38', -1, '20050405'],
  ['20050405', 1, '1.8'],
  ['1.8', -1, '2.11-r1'],
  ['2.11-r1', 1, '2.11'],
  ['2.11', 1, '0.1.6-r3'],
  ['0.1.6-r3', -1, '0.47-r1'],
  ['0.47-r1', -1, '0.49'],
  ['0.49', -1, '3.6.8-r2'],
  ['3.6.8-r2', 1, '1.39'],
  ['1.39', -1, '2.43'],
  ['2.43', 1, '2.0.6-r1'],
  ['2.0.6-r1', 1, '0.2-r6'],
  ['0.2-r6', -1, '0.4'],
  ['0.4', -1, '1.0.0'],
  ['1.0.0', -1, '10-r1'],
  ['10-r1', 1, '4'],
  ['4', 1, '0.7.3-r2'],
  ['0.7.3-r2', 1, '0.7.3'],
  ['0.7.3', -1, '1.95.8'],
  ['1.95.8', 1, '1.1.19'],
  ['1.1.19', 1, '1.1.5'],
  ['1.1.5', -1, '6.3.2-r1'],
  ['6.3.2-r1', -1, '6.3.3'],
  ['6.3.3', 1, '4.17-r1'],
  ['4.17-r1', -1, '4.18'],
  ['4.18', -1, '4.19'],
  ['4.19', 1, '4.3.0'],
  ['4.3.0', -1, '4.3.2-r1'],
  ['4.3.2-r1', 1, '4.3.2'],
  ['4.3.2', 1, '0.68-r3'],
  ['0.68-r3', -1, '1.0.0'],
  ['1.0.0', -1, '1.0.1'],
  ['1.0.1', 1, '1.0.0'],
  ['1.0.0', 0, '1.0.0'],
  ['1.0.0', -1, '1.0.1'],
  ['1.0.1', -1, '2.3.2-r1'],
  ['2.3.2-r1', -1, '2.4.2'],
  ['2.4.2', -1, '20060720'],
  ['20060720', 1, '3.0.20060720'],
  ['3.0.20060720', -1, '20060720'],
  ['20060720', 1, '1.1'],
  ['1.1', 0, '1.1'],
  ['1.1', -1, '1.1.1-r1'],
  ['1.1.1-r1', -1, '1.1.3-r1'],
  ['1.1.3-r1', -1, '1.1.3-r2'],
  ['1.1.3-r2', -1, '2.1.10-r2'],
  ['2.1.10-r2', 1, '0.7.18-r2'],
  ['0.7.18-r2', -1, '0.17-r6'],
  ['0.17-r6', -1, '2.6.1'],
  ['2.6.1', -1, '2.6.3'],
  ['2.6.3', -1, '3.1.5-r2'],
  ['3.1.5-r2', -1, '3.4.6-r1'],
  ['3.4.6-r1', -1, '3.4.6-r2'],
  ['3.4.6-r2', 0, '3.4.6-r2'],
  ['3.4.6-r2', 1, '2.0.33'],
  ['2.0.33', -1, '2.0.34'],
  ['2.0.34', 1, '1.8.3-r2'],
  ['1.8.3-r2', -1, '1.8.3-r3'],
  ['1.8.3-r3', -1, '4.1'],
  ['4.1', -1, '8.54'],
  ['8.54', 1, '4.1.4'],
  ['4.1.4', 1, '1.2.10-r5'],
  ['1.2.10-r5', -1, '4.1.4-r3'],
  ['4.1.4-r3', 0, '4.1.4-r3'],
  ['4.1.4-r3', -1, '4.2.1'],
  ['4.2.1', 1, '4.1.0'],
  ['4.1.0', -1, '8.11'],
  ['8.11', 1, '1.4.4-r1'],
  ['1.4.4-r1', -1, '2.1.9.200602141850'],
  ['2.1.9.200602141850', 1, '1.6'],
  ['1.6', -1, '2.5.1-r8'],
  ['2.5.1-r8', -1, '2.5.1a-r1'],
  ['2.5.1a-r1', 1, '1.19.2-r1'],
  ['1.19.2-r1', 1, '0.97-r2'],
  ['0.97-r2', -1, '0.97-r3'],
  ['0.97-r3', -1, '1.3.5-r10'],
  ['1.3.5-r10', 1, '1.3.5-r8'],
  ['1.3.5-r8', -1, '1.3.5-r9'],
  ['1.3.5-r9', 1, '1.0'],
  ['1.0', -1, '1.1'],
  ['1.1', 1, '0.9.11'],
  ['0.9.11', -1, '0.9.12'],
  ['0.9.12', -1, '0.9.13'],
  ['0.9.13', -1, '0.9.14'],
  ['0.9.14', -1, '0.9.15'],
  ['0.9.15', -1, '0.9.16'],
  ['0.9.16', 1, '0.3-r2'],
  ['0.3-r2', -1, '6.3'],
  ['6.3', -1, '6.6'],
  ['6.6', -1, '6.9'],
  ['6.9', 1, '0.7.2-r3'],
  ['0.7.2-r3', -1, '1.2.10'],
  ['1.2.10', -1, '20040923-r2'],
  ['20040923-r2', 1, '20040401'],
  ['20040401', 1, '2.0.0_rc3-r1'],
  ['2.0.0_rc3-r1', 1, '1.5'],
  ['1.5', -1, '4.4'],
  ['4.4', 1, '1.0.1'],
  ['1.0.1', -1, '2.2.0'],
  ['2.2.0', 1, '1.1.0-r2'],
  ['1.1.0-r2', 1, '0.3'],
  ['0.3', -1, '20020207-r2'],
  ['20020207-r2', 1, '1.31-r2'],
  ['1.31-r2', -1, '3.7'],
  ['3.7', 1, '2.0.1'],
  ['2.0.1', -1, '2.0.2'],
  ['2.0.2', 1, '0.99.163'],
  ['0.99.163', -1, '2.6.15.20060110'],
  ['2.6.15.20060110', -1, '2.6.16.20060323'],
  ['2.6.16.20060323', -1, '2.6.19.20061214'],
  ['2.6.19.20061214', 1, '0.6.2-r1'],
  ['0.6.2-r1', -1, '0.6.3'],
  ['0.6.3', -1, '0.6.5'],
  ['0.6.5', -1, '1.3.5-r1'],
  ['1.3.5-r1', -1, '1.3.5-r4'],
  ['1.3.5-r4', -1, '3.0.0-r2'],
  # ['3.0.0-r2', -1, '021109-r3'], # Numbers with leading zero not supported yet
  # ['021109-r3', -1, '20060512'], # Numbers with leading zero not supported yet
  ['20060512', 1, '1.24'],
  ['1.24', 1, '0.9.16-r1'],
  ['0.9.16-r1', -1, '3.9_pre20060124'],
  # ['3.9_pre20060124', 1, '0.01'], # Numbers with leading zero not supported yet
  # ['0.01', -1, '0.06'], # Numbers with leading zero not supported yet
  # ['0.06', -1, '1.1.7'], # Numbers with leading zero not supported yet
  ['1.1.7', -1, '6b-r7'],
  ['6b-r7', 1, '1.12-r7'],
  ['1.12-r7', -1, '1.12-r8'],
  ['1.12-r8', 1, '1.1.12'],
  ['1.1.12', -1, '1.1.13'],
  ['1.1.13', 1, '0.3'],
  ['0.3', -1, '0.5'],
  ['0.5', -1, '3.96.1'],
  ['3.96.1', -1, '3.97'],
  ['3.97', 1, '0.10.0-r1'],
  ['0.10.0-r1', 1, '0.10.0'],
  ['0.10.0', -1, '0.10.1_rc1'],
  ['0.10.1_rc1', 1, '0.9.11'],
  ['0.9.11', -1, '394'],
  ['394', 1, '2.31'],
  ['2.31', 1, '1.0.1'],
  ['1.0.1', 0, '1.0.1'],
  ['1.0.1', -1, '1.0.3'],
  ['1.0.3', 1, '1.0.2'],
  ['1.0.2', 0, '1.0.2'],
  ['1.0.2', 1, '1.0.1'],
  ['1.0.1', 0, '1.0.1'],
  ['1.0.1', -1, '1.2.2'],
  ['1.2.2', -1, '2.1.10'],
  ['2.1.10', 1, '1.0.1'],
  ['1.0.1', -1, '1.0.2'],
  ['1.0.2', -1, '3.5.5'],
  ['3.5.5', 1, '1.1.1'],
  ['1.1.1', 1, '0.9.1'],
  ['0.9.1', -1, '1.0.2'],
  ['1.0.2', 1, '1.0.1'],
  ['1.0.1', -1, '1.0.2'],
  ['1.0.2', 1, '1.0.1'],
  ['1.0.1', 0, '1.0.1'],
  ['1.0.1', -1, '1.0.5'],
  ['1.0.5', 1, '0.8.5'],
  ['0.8.5', -1, '0.8.6-r3'],
  ['0.8.6-r3', -1, '2.3.17'],
  ['2.3.17', 1, '1.10-r5'],
  ['1.10-r5', -1, '1.10-r9'],
  ['1.10-r9', -1, '2.0.2'],
  ['2.0.2', 1, '1.1a'],
  ['1.1a', -1, '1.3a'],
  ['1.3a', 1, '1.0.2'],
  ['1.0.2', -1, '1.2.2-r1'],
  ['1.2.2-r1', 1, '1.0-r1'],
  ['1.0-r1', 1, '0.15.1b'],
  ['0.15.1b', -1, '1.0.1'],
  # ['1.0.1', -1, '1.06-r1'], # Numbers with leading zero not supported yet
  # ['1.06-r1', -1, '1.06-r2'], # Numbers with leading zero not supported yet
  # ['1.06-r2', 1, '0.15.1b-r2'], # Numbers with leading zero not supported yet
  ['0.15.1b-r2', 1, '0.15.1b'],
  ['0.15.1b', -1, '2.5.7'],
  ['2.5.7', 1, '1.1.2.1-r1'],
  ['1.1.2.1-r1', 1, '0.0.31'],
  ['0.0.31', -1, '0.0.50'],
  ['0.0.50', 1, '0.0.16'],
  ['0.0.16', -1, '0.0.25'],
  ['0.0.25', -1, '0.17'],
  ['0.17', 1, '0.5.0'],
  ['0.5.0', -1, '1.1.2'],
  ['1.1.2', -1, '1.1.3'],
  ['1.1.3', -1, '1.1.20'],
  ['1.1.20', 1, '0.9.4'],
  ['0.9.4', -1, '0.9.5'],
  ['0.9.5', -1, '6.3'],
  ['6.3', -1, '6.6'],
  ['6.6', 1, '6.3'],
  ['6.3', -1, '6.6'],
  ['6.6', 1, '1.2.12-r1'],
  ['1.2.12-r1', -1, '1.2.13'],
  ['1.2.13', -1, '1.2.14'],
  ['1.2.14', -1, '1.2.15'],
  ['1.2.15', -1, '8.0.12'],
  ['8.0.12', 1, '8.0.9'],
  ['8.0.9', 1, '1.2.3-r1'],
  ['1.2.3-r1', -1, '1.2.4-r1'],
  ['1.2.4-r1', 1, '0.1'],
  ['0.1', -1, '0.3.5'],
  ['0.3.5', -1, '1.5.22'],
  ['1.5.22', 1, '0.1.11'],
  ['0.1.11', -1, '0.1.12'],
  ['0.1.12', -1, '1.1.4.1'],
  ['1.1.4.1', 1, '1.1.0'],
  ['1.1.0', -1, '1.1.2'],
  ['1.1.2', 1, '1.0.3'],
  ['1.0.3', 1, '1.0.2'],
  ['1.0.2', -1, '2.6.26'],
  ['2.6.26', -1, '2.6.27'],
  ['2.6.27', 1, '1.1.17'],
  ['1.1.17', -1, '1.4.11'],
  ['1.4.11', -1, '22.7-r1'],
  ['22.7-r1', -1, '22.7.3-r1'],
  ['22.7.3-r1', 1, '22.7'],
  ['22.7', 1, '2.1_pre20'],
  ['2.1_pre20', -1, '2.1_pre26'],
  ['2.1_pre26', 1, '0.2.3-r2'],
  ['0.2.3-r2', 1, '0.2.2'],
  ['0.2.2', -1, '2.10.0'],
  ['2.10.0', -1, '2.10.1'],
  # ['2.10.1', 1, '02.08.01b'], # Numbers with leading zero not supported yet
  # ['02.08.01b', -1, '4.77'], # Numbers with leading zero not supported yet
  ['4.77', 1, '0.17'],
  ['0.17', -1, '5.1.1-r1'],
  ['5.1.1-r1', -1, '5.1.1-r2'],
  ['5.1.1-r2', 1, '5.1.1'],
  ['5.1.1', 1, '1.2'],
  ['1.2', -1, '5.1'],
  # ['5.1', 1, '2.02.06'], # Numbers with leading zero not supported yet
  # ['2.02.06', -1, '2.02.10'], # Numbers with leading zero not supported yet
  # ['2.02.10', -1, '2.8.5-r3'], # Numbers with leading zero not supported yet
  ['2.8.5-r3', -1, '2.8.6-r1'],
  ['2.8.6-r1', -1, '2.8.6-r2'],
  # ['2.8.6-r2', 1, '2.02-r1'], # Numbers with leading zero not supported yet
  # ['2.02-r1', 1, '1.5.0-r1'], # Numbers with leading zero not supported yet
  ['1.5.0-r1', 1, '1.5.0'],
  ['1.5.0', 1, '0.9.2'],
  ['0.9.2', -1, '8.1.2.20040524-r1'],
  ['8.1.2.20040524-r1', -1, '8.1.2.20050715-r1'],
  ['8.1.2.20050715-r1', -1, '20030215'],
  ['20030215', 1, '3.80-r4'],
  ['3.80-r4', -1, '3.81'],
  ['3.81', 1, '1.6d'],
  # ['1.6d', 1, '1.2.07.8'], # Numbers with leading zero not supported yet
  # ['1.2.07.8', -1, '1.2.12.04'], # Numbers with leading zero not supported yet
  # ['1.2.12.04', -1, '1.2.12.05'], # Numbers with leading zero not supported yet
  # ['1.2.12.05', -1, '1.3.3'], # Numbers with leading zero not supported yet
  ['1.3.3', -1, '2.6.4'],
  ['2.6.4', 1, '2.5.2'],
  ['2.5.2', -1, '2.6.1'],
  ['2.6.1', 1, '2.6'],
  ['2.6', -1, '6.5.1-r1'],
  ['6.5.1-r1', 1, '1.1.35-r1'],
  ['1.1.35-r1', -1, '1.1.35-r2'],
  ['1.1.35-r2', 1, '0.9.2'],
  # ['0.9.2', -1, '1.07-r1'], # Numbers with leading zero not supported yet
  # ['1.07-r1', -1, '1.07.5'], # Numbers with leading zero not supported yet
  # ['1.07.5', 1, '1.07'], # Numbers with leading zero not supported yet
  # ['1.07', -1, '1.19'], # Numbers with leading zero not supported yet
  ['1.19', -1, '2.1-r2'],
  ['2.1-r2', -1, '2.2'],
  ['2.2', 1, '1.0.4'],
  ['1.0.4', -1, '20060811'],
  ['20060811', -1, '20061003'],
  ['20061003', 1, '0.1_pre20060810'],
  ['0.1_pre20060810', -1, '0.1_pre20060817'],
  ['0.1_pre20060817', -1, '1.0.3'],
  ['1.0.3', 1, '1.0.2'],
  ['1.0.2', 1, '1.0.1'],
  ['1.0.1', -1, '3.2.2-r1'],
  ['3.2.2-r1', -1, '3.2.2-r2'],
  ['3.2.2-r2', -1, '3.3.17'],
  ['3.3.17', 1, '0.59s-r11'],
  ['0.59s-r11', -1, '0.65'],
  ['0.65', 1, '0.2.10-r2'],
  # ['0.2.10-r2', -1, '2.01'], # Numbers with leading zero not supported yet
  # ['2.01', -1, '3.9.10'], # Numbers with leading zero not supported yet
  ['3.9.10', 1, '1.2.18'],
  ['1.2.18', -1, '1.5.11-r2'],
  ['1.5.11-r2', -1, '1.5.13-r1'],
  ['1.5.13-r1', 1, '1.3.12-r1'],
  ['1.3.12-r1', -1, '2.0.1'],
  ['2.0.1', -1, '2.0.2'],
  ['2.0.2', -1, '2.0.3'],
  ['2.0.3', 1, '0.2.0'],
  ['0.2.0', -1, '5.5-r2'],
  ['5.5-r2', -1, '5.5-r3'],
  ['5.5-r3', 1, '0.25.3'],
  ['0.25.3', -1, '0.26.1-r1'],
  ['0.26.1-r1', -1, '5.2.1.2-r1'],
  ['5.2.1.2-r1', -1, '5.4'],
  ['5.4', 1, '1.60-r11'],
  ['1.60-r11', -1, '1.60-r12'],
  ['1.60-r12', -1, '110-r8'],
  ['110-r8', 1, '0.17-r2'],
  # ['0.17-r2', -1, '1.05-r4'], # Numbers with leading zero not supported yet
  # ['1.05-r4', -1, '5.28.0'], # Numbers with leading zero not supported yet
  ['5.28.0', 1, '0.51.6-r1'],
  ['0.51.6-r1', -1, '1.0.6-r6'],
  ['1.0.6-r6', 1, '0.8.3'],
  ['0.8.3', -1, '1.42'],
  ['1.42', -1, '20030719'],
  # ['20030719', 1, '4.01'], # Numbers with leading zero not supported yet
  # ['4.01', -1, '4.20'], # Numbers with leading zero not supported yet
  ['4.20', 1, '0.20070118'],
  ['0.20070118', -1, '0.20070207_rc1'],
  ['0.20070207_rc1', -1, '1.0'],
  ['1.0', -1, '1.13.0'],
  ['1.13.0', -1, '1.13.1'],
  ['1.13.1', 1, '0.21'],
  ['0.21', 1, '0.3.7-r3'],
  ['0.3.7-r3', -1, '0.4.10'],
  ['0.4.10', -1, '0.5.0'],
  ['0.5.0', -1, '0.5.5'],
  ['0.5.5', -1, '0.5.7'],
  ['0.5.7', -1, '0.6.11-r1'],
  ['0.6.11-r1', -1, '2.3.30-r2'],
  ['2.3.30-r2', -1, '3.7_p1'],
  ['3.7_p1', 1, '1.3'],
  ['1.3', 1, '0.10.1'],
  ['0.10.1', -1, '4.3_p2-r1'],
  ['4.3_p2-r1', -1, '4.3_p2-r5'],
  ['4.3_p2-r5', -1, '4.4_p1-r6'],
  ['4.4_p1-r6', -1, '4.5_p1-r1'],
  ['4.5_p1-r1', 1, '4.5_p1'],
  ['4.5_p1', -1, '4.5_p1-r1'],
  ['4.5_p1-r1', 1, '4.5_p1'],
  ['4.5_p1', 1, '0.9.8c-r1'],
  ['0.9.8c-r1', -1, '0.9.8d'],
  ['0.9.8d', -1, '2.4.4'],
  ['2.4.4', -1, '2.4.7'],
  ['2.4.7', 1, '2.0.6'],
  ['2.0.6', 0, '2.0.6'],
  ['2.0.6', 1, '0.78-r3'],
  ['0.78-r3', 1, '0.3.2'],
  ['0.3.2', -1, '1.7.1-r1'],
  ['1.7.1-r1', -1, '2.5.9'],
  ['2.5.9', 1, '0.1.13'],
  ['0.1.13', -1, '0.1.15'],
  ['0.1.15', -1, '0.4'],
  ['0.4', -1, '0.9.6'],
  ['0.9.6', -1, '2.2.0-r1'],
  ['2.2.0-r1', -1, '2.2.3-r2'],
  # ['2.2.3-r2', -1, '013'], # Numbers with leading zero not supported yet
  # ['013', -1, '014-r1'], # Numbers with leading zero not supported yet
  # ['014-r1', 1, '1.3.1-r1'], # Numbers with leading zero not supported yet
  ['1.3.1-r1', -1, '5.8.8-r2'],
  ['5.8.8-r2', 1, '5.1.6-r4'],
  ['5.1.6-r4', -1, '5.1.6-r6'],
  ['5.1.6-r6', -1, '5.2.1-r3'],
  ['5.2.1-r3', 1, '0.11.3'],
  ['0.11.3', 0, '0.11.3'],
  ['0.11.3', -1, '1.10.7'],
  ['1.10.7', 1, '1.7-r1'],
  ['1.7-r1', 1, '0.1.20'],
  ['0.1.20', -1, '0.1.23'],
  ['0.1.23', -1, '5b-r9'],
  ['5b-r9', 1, '2.2.10'],
  ['2.2.10', -1, '2.3.6'],
  ['2.3.6', -1, '8.0.12'],
  ['8.0.12', 1, '2.4.3-r16'],
  ['2.4.3-r16', -1, '2.4.4-r4'],
  ['2.4.4-r4', -1, '3.0.3-r5'],
  ['3.0.3-r5', -1, '3.0.6'],
  ['3.0.6', -1, '3.2.6'],
  ['3.2.6', -1, '3.2.7'],
  ['3.2.7', 1, '0.3.1_rc8'],
  ['0.3.1_rc8', -1, '22.2'],
  ['22.2', -1, '22.3'],
  ['22.3', 1, '1.2.2'],
  # ['1.2.2', -1, '2.04'], # Numbers with leading zero not supported yet
  # ['2.04', -1, '2.4.3-r1'], # Numbers with leading zero not supported yet
  ['2.4.3-r1', -1, '2.4.3-r4'],
  ['2.4.3-r4', 1, '0.98.6-r1'],
  ['0.98.6-r1', -1, '5.7-r2'],
  ['5.7-r2', -1, '5.7-r3'],
  ['5.7-r3', 1, '5.1_p4'],
  ['5.1_p4', 1, '1.0.5'],
  ['1.0.5', -1, '3.6.19-r1'],
  ['3.6.19-r1', 1, '3.6.19'],
  ['3.6.19', 1, '1.0.1'],
  ['1.0.1', -1, '3.8'],
  ['3.8', 1, '0.2.3'],
  ['0.2.3', -1, '1.2.15-r3'],
  ['1.2.15-r3', 1, '1.2.6-r1'],
  ['1.2.6-r1', -1, '2.6.8-r2'],
  ['2.6.8-r2', -1, '2.6.9-r1'],
  ['2.6.9-r1', 1, '1.7'],
  ['1.7', -1, '1.7b'],
  ['1.7b', -1, '1.8.4-r3'],
  ['1.8.4-r3', -1, '1.8.5'],
  ['1.8.5', -1, '1.8.5_p2'],
  ['1.8.5_p2', 1, '1.1.3'],
  ['1.1.3', -1, '3.0.22-r3'],
  ['3.0.22-r3', -1, '3.0.24'],
  ['3.0.24', 0, '3.0.24'],
  ['3.0.24', 0, '3.0.24'],
  ['3.0.24', -1, '4.0.2-r5'],
  ['4.0.2-r5', -1, '4.0.3'],
  ['4.0.3', 1, '0.98'],
  # ['0.98', -1, '1.00'], # Numbers with leading zero not supported yet
  # ['1.00', -1, '4.1.4-r1'], # Numbers with leading zero not supported yet
  ['4.1.4-r1', -1, '4.1.5'],
  ['4.1.5', 1, '2.3'],
  ['2.3', -1, '2.17-r3'],
  ['2.17-r3', 1, '0.1.7'],
  ['0.1.7', -1, '1.11'],
  ['1.11', -1, '4.2.1-r11'],
  ['4.2.1-r11', 1, '3.2.3'],
  ['3.2.3', -1, '3.2.4'],
  ['3.2.4', -1, '3.2.8'],
  ['3.2.8', -1, '3.2.9'],
  ['3.2.9', 1, '3.2.3'],
  ['3.2.3', -1, '3.2.4'],
  ['3.2.4', -1, '3.2.8'],
  ['3.2.8', -1, '3.2.9'],
  ['3.2.9', 1, '1.4.9-r2'],
  ['1.4.9-r2', -1, '2.9.11_pre20051101-r2'],
  ['2.9.11_pre20051101-r2', -1, '2.9.11_pre20051101-r3'],
  ['2.9.11_pre20051101-r3', 1, '2.9.11_pre20051101'],
  ['2.9.11_pre20051101', -1, '2.9.11_pre20061021-r1'],
  ['2.9.11_pre20061021-r1', -1, '2.9.11_pre20061021-r2'],
  ['2.9.11_pre20061021-r2', -1, '5.36-r1'],
  ['5.36-r1', 1, '1.0.1'],
  ['1.0.1', -1, '7.0-r2'],
  ['7.0-r2', 1, '2.4.5'],
  ['2.4.5', -1, '2.6.1.2'],
  ['2.6.1.2', -1, '2.6.1.3-r1'],
  ['2.6.1.3-r1', 1, '2.6.1.3'],
  ['2.6.1.3', -1, '2.6.1.3-r1'],
  ['2.6.1.3-r1', -1, '12.17.9'],
  ['12.17.9', 1, '1.1.12'],
  ['1.1.12', 1, '1.1.7'],
  ['1.1.7', -1, '2.5.14'],
  ['2.5.14', -1, '2.6.6-r1'],
  ['2.6.6-r1', -1, '2.6.7'],
  ['2.6.7', -1, '2.6.9-r1'],
  ['2.6.9-r1', 1, '2.6.9'],
  ['2.6.9', 1, '1.39'],
  ['1.39', 1, '0.9'],
  ['0.9', -1, '2.61-r2'],
  ['2.61-r2', -1, '4.5.14'],
  # ['4.5.14', 1, '4.09-r1'], # Numbers with leading zero not supported yet
  # ['4.09-r1', 1, '1.3.1'], # Numbers with leading zero not supported yet
  ['1.3.1', -1, '1.3.2-r3'],
  ['1.3.2-r3', -1, '1.6.8_p12-r1'],
  ['1.6.8_p12-r1', 1, '1.6.8_p9-r2'],
  ['1.6.8_p9-r2', 1, '1.3.0-r1'],
  ['1.3.0-r1', -1, '3.11'],
  ['3.11', -1, '3.20'],
  ['3.20', 1, '1.6.11-r1'],
  ['1.6.11-r1', 1, '1.6.9'],
  ['1.6.9', -1, '5.0.5-r2'],
  ['5.0.5-r2', 1, '2.86-r5'],
  ['2.86-r5', -1, '2.86-r6'],
  ['2.86-r6', 1, '1.15.1-r1'],
  ['1.15.1-r1', -1, '8.4.9'],
  ['8.4.9', 1, '7.6-r8'],
  ['7.6-r8', 1, '3.9.4-r2'],
  ['3.9.4-r2', -1, '3.9.4-r3'],
  ['3.9.4-r3', -1, '3.9.5-r2'],
  ['3.9.5-r2', 1, '1.1.9'],
  ['1.1.9', 1, '1.0.6'],
  ['1.0.6', -1, '5.9'],
  ['5.9', -1, '6.5'],
  ['6.5', 1, '0.40-r1'],
  ['0.40-r1', -1, '2.25b-r5'],
  ['2.25b-r5', -1, '2.25b-r6'],
  ['2.25b-r6', 1, '1.0.4'],
  ['1.0.4', -1, '1.0.5'],
  ['1.0.5', -1, '1.4_p12-r2'],
  ['1.4_p12-r2', -1, '1.4_p12-r5'],
  ['1.4_p12-r5', 1, '1.1'],
  ['1.1', 1, '0.2.0-r1'],
  ['0.2.0-r1', -1, '0.2.1'],
  ['0.2.1', -1, '0.9.28-r1'],
  ['0.9.28-r1', -1, '0.9.28-r2'],
  ['0.9.28-r2', -1, '0.9.28.1'],
  ['0.9.28.1', 1, '0.9.28'],
  ['0.9.28', -1, '0.9.28.1'],
  # ['0.9.28.1', -1, '087-r1'], # Numbers with leading zero not supported yet
  # ['087-r1', -1, '103'], # Numbers with leading zero not supported yet
  ['103', -1, '104-r11'],
  ['104-r11', 1, '104-r9'],
  ['104-r9', 1, '1.23-r1'],
  ['1.23-r1', 1, '1.23'],
  ['1.23', -1, '1.23-r1'],
  ['1.23-r1', 1, '1.0.2'],
  ['1.0.2', -1, '5.52-r1'],
  ['5.52-r1', 1, '1.2.5_rc2'],
  ['1.2.5_rc2', 1, '0.1'],
  ['0.1', -1, '0.71-r1'],
  ['0.71-r1', -1, '20040406-r1'],
  ['20040406-r1', 1, '2.12r-r4'],
  ['2.12r-r4', -1, '2.12r-r5'],
  ['2.12r-r5', 1, '0.0.7'],
  ['0.0.7', -1, '1.0.3'],
  ['1.0.3', -1, '1.8'],
  ['1.8', -1, '7.0.17'],
  ['7.0.17', -1, '7.0.174'],
  ['7.0.174', 1, '7.0.17'],
  ['7.0.17', -1, '7.0.174'],
  ['7.0.174', 1, '1.0.1'],
  ['1.0.1', -1, '1.1.1-r3'],
  ['1.1.1-r3', 1, '0.3.4_pre20061029'],
  ['0.3.4_pre20061029', -1, '0.4.0'],
  ['0.4.0', 1, '0.1.2'],
  ['0.1.2', -1, '1.10.2'],
  ['1.10.2', -1, '2.16'],
  ['2.16', -1, '28'],
  ['28', 1, '0.99.4'],
  ['0.99.4', -1, '1.13'],
  ['1.13', 1, '1.0.1'],
  ['1.0.1', -1, '1.1.2-r2'],
  ['1.1.2-r2', 1, '1.1.0'],
  ['1.1.0', -1, '1.1.1'],
  ['1.1.1', 0, '1.1.1'],
  ['1.1.1', 1, '0.6.0'],
  ['0.6.0', -1, '6.6.3'],
  ['6.6.3', 1, '1.1.1'],
  ['1.1.1', 1, '1.1.0'],
  ['1.1.0', 0, '1.1.0'],
  ['1.1.0', 1, '0.2.0'],
  ['0.2.0', -1, '0.3.0'],
  ['0.3.0', -1, '1.1.1'],
  ['1.1.1', -1, '1.2.0'],
  ['1.2.0', 1, '1.1.0'],
  ['1.1.0', -1, '1.6.5'],
  ['1.6.5', 1, '1.1.0'],
  ['1.1.0', -1, '1.4.2'],
  ['1.4.2', 1, '1.1.1'],
  ['1.1.1', -1, '2.8.1'],
  ['2.8.1', 1, '1.2.0'],
  ['1.2.0', -1, '4.1.0'],
  ['4.1.0', 1, '0.4.1'],
  ['0.4.1', -1, '1.9.1'],
  ['1.9.1', -1, '2.1.1'],
  ['2.1.1', 1, '1.4.1'],
  ['1.4.1', 1, '0.9.1-r1'],
  ['0.9.1-r1', 1, '0.8.1'],
  ['0.8.1', -1, '1.2.1-r1'],
  ['1.2.1-r1', 1, '1.1.0'],
  ['1.1.0', -1, '1.2.1'],
  ['1.2.1', 1, '1.1.0'],
  ['1.1.0', 1, '0.1.1'],
  ['0.1.1', -1, '1.2.1'],
  ['1.2.1', -1, '4.1.0'],
  ['4.1.0', 1, '0.2.1-r1'],
  ['0.2.1-r1', -1, '1.1.0'],
  ['1.1.0', -1, '2.7.11'],
  ['2.7.11', 1, '1.0.2-r6'],
  ['1.0.2-r6', 1, '1.0.2'],
  ['1.0.2', 1, '0.8'],
  ['0.8', -1, '1.1.1-r4'],
  ['1.1.1-r4', -1, '222'],
  ['222', 1, '1.0.1'],
  ['1.0.1', -1, '1.2.12-r1'],
  ['1.2.12-r1', 1, '1.2.8'],
  ['1.2.8', -1, '1.2.9.1-r1'],
  ['1.2.9.1-r1', 1, '1.2.9.1'],
  ['1.2.9.1', -1, '2.31-r1'],
  ['2.31-r1', 1, '2.31'],
  ['2.31', 1, '1.2.3-r1'],
  ['1.2.3-r1', 1, '1.2.3'],
  ['1.2.3', -1, '4.2.5'],
  ['4.2.5', -1, '4.3.2-r2'],
  ['1.3-r0', -1, '1.3.1-r0'],
  ['1.3_pre1-r1', -1, '1.3.2'],
  ['1.0_p10-r0', 1, '1.0_p9-r0'],
  # ['0.1.0_alpha_pre2', -1, '0.1.0_alpha'], # Multiple suffixes not supported yet
  ['1.0.0_pre20191002222144-r0', -1, '1.0.0_pre20210530193627-r0']
].freeze
